> ## Documentation Index
> Fetch the complete documentation index at: https://docs.chkk.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Update Project

> Update an existing Project

A <em>Project</em> is software that provides some functionality.

Projects are uniquely identified by a UUID, prefixed with the string
<b>proj_</b>, for example <b>proj_c42014e7-baf5-4ec6-a502-858f98dca7c8</b>

Projects can have zero or more <em>Aliases</em>. Aliases are completely free-form.
They can be a URL, like <b>github.com/kubernetes/kubernetes</b> or a short string
like <b>k8s</b> or <b>kube</b>.

Each Project has a <em>ProjectType</em>. Valid ProjectTypes include:

* <b>platform</b>: The Project represents a software platform, such as the
  Project itself.
* <b>kube-addon</b>: The Project represents a Cloud Native Project, which is defined as
  some software that extends the functionality of the cluster and
  its API.
* <b>kube-operator</b>: The Project represents a Kubernetes [Operator][operator],
  which is defined as software written specifically against the API
  and is responsible for installing and managing the lifecycle of a Kubernetes
  Addon or Application Service.
* <b>kube-control-plane-provider</b>: The Project represents a Kubernetes control
  plane service, such as RKE, GKE or EKS.
* <b>application-service</b>: The Project represents application code that provides
  essential services to the rest of the application stack.
* <b>application</b>: The Project represents customer-specific or internal code.

A Project is <em>not</em> the packaging of that software. Packaging of
Projects is described by the Package model.




## OpenAPI

````yaml put /projects/{project}/
openapi: 3.1.0
info:
  description: >

    The Chkk Artifact Register API exposes information about the artifacts in a

    customer's clusters.


    Data models exposed in the Chkk Artifact Register API include:


    * <b>Organization</b>: the top-level object that models a Chkk customer.

    * <b>Account</b>: a container for resource ownership within an Organization.

    * <b>KubePlatform</b>: describes things like the cloud infrastructure
    provider
      and the control plane provider.
    * <b>KubeCluster</b>: a single cluster provisioned by a
      KubePlatform.
    * <b>KubeClusterScan</b>: a single Chkk scan of a cluster.

    * <b>KubeClusterResource</b>: a single Resource
      (Deployment, DaemonSet or StatefulSet) from a KubeClusterScan.
    * <b>KubeClusterResourceContainer</b>: a single container record in a
      KubeClusterResource.
    * <b>Project</b>: software that provides some functionality.

    * <b>ProjectReleaseSeries</b>: a single release series for a Project.

    * <b>ProjectRelease</b>: a single release for a Project.

    * <b>ProjectVersionSet</b>: a configuration, layout or structure of a
    Project
      that is consistent for a range of ProjectReleases.
    * <b>ProjectComponent</b>: a separate binary, daemon, or subsystem of a
      Project.
    * <b>Package</b>: a named bundle of software that is bundled (and
      identified) in the format of a specific PackageSystem.
    * <b>PackageRelease</b>: a single release for a Package.

    * <b>PackageVersionSet</b>: a configuration, layout or structure of a
    Package
      that is consistent for a range of PackageReleases.
    * <b>OCIRepository</b>: a single namespace within an OCI Registry.

    * <b>OCIArtifact</b>: a single OCI Artifact (manifest) that describes an OCI
      Image or other OCI Artifact.
    * <b>OCITag</b>: a name that points to a unique OCIArtifact within an
      OCIRepository.
    * <b>OCIReference</b>: a relationship between an OCITag and an OCIArtifact.

    * <b>RiskSignature</b>: the source of a <em>potential</em>
      availability or operational risk for a customer.
    * <b>Risk</b>: a <em>detected</em> RiskSignature for an Account.

    * <b>UpgradeTemplate</b>: detailed instructions for upgrading or migrating a
      KubeCluster or an installed part of a KubeCluster. 
  title: Chkk API
  version: '1.0'
servers: []
security: []
paths:
  /projects/{project}/:
    put:
      tags:
        - Project
      summary: Update Project
      description: >
        Update an existing Project


        A <em>Project</em> is software that provides some functionality.


        Projects are uniquely identified by a UUID, prefixed with the string

        <b>proj_</b>, for example
        <b>proj_c42014e7-baf5-4ec6-a502-858f98dca7c8</b>


        Projects can have zero or more <em>Aliases</em>. Aliases are completely
        free-form.

        They can be a URL, like <b>github.com/kubernetes/kubernetes</b> or a
        short string

        like <b>k8s</b> or <b>kube</b>.


        Each Project has a <em>ProjectType</em>. Valid ProjectTypes include:


        * <b>platform</b>: The Project represents a software platform, such as
        the
          Project itself.
        * <b>kube-addon</b>: The Project represents a Cloud Native Project,
        which is defined as
          some software that extends the functionality of the cluster and
          its API.
        * <b>kube-operator</b>: The Project represents a Kubernetes
        [Operator][operator],
          which is defined as software written specifically against the API
          and is responsible for installing and managing the lifecycle of a Kubernetes
          Addon or Application Service.
        * <b>kube-control-plane-provider</b>: The Project represents a
        Kubernetes control
          plane service, such as RKE, GKE or EKS.
        * <b>application-service</b>: The Project represents application code
        that provides
          essential services to the rest of the application stack.
        * <b>application</b>: The Project represents customer-specific or
        internal code.


        A Project is <em>not</em> the packaging of that software. Packaging of

        Projects is described by the Package model.
      operationId: project-update
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Project'
          description: OK
        default:
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/ErrorModel'
          description: Error
components:
  schemas:
    Project:
      additionalProperties: false
      properties:
        $schema:
          description: A URL to the JSON Schema for this object.
          examples:
            - https://example.com/schemas/Project.json
          format: uri
          readOnly: true
          type: string
        aliases:
          description: >-
            Optional set of string aliases for the Project. Must be globally
            unique.
          examples:
            - - prom
          items:
            type: string
          type:
            - array
            - 'null'
        created_by:
          description: user who created the record.
          type: string
        created_on:
          description: timestamp of when the record was created.
          format: date-time
          type: string
        description:
          description: Optional long-form description of the Project.
          type: string
        id:
          description: ID is the unique identifier for the Project
          examples:
            - proj_260fc3e8-1acb-4268-8a63-447792b0c2f4
          type: string
        last_modified_by:
          description: user who last modified the record.
          type: string
        last_modified_on:
          description: timestamp of when the record was last modified.
          format: date-time
          type: string
        title:
          description: Display name for the Project.
          examples:
            - Prometheus
          type: string
        type:
          description: Type is the type of Project.
          enum:
            - kube-addon
            - kube-operator
            - kube-control-plane-provider
            - application-service
            - platform
            - application
          examples:
            - application-service
          type: string
        versioning:
          $ref: '#/components/schemas/Versioning'
          description: >-
            An optional object containing information about the Project's
            versioning and release model.
      required:
        - type
        - title
        - id
        - created_by
        - created_on
        - last_modified_by
        - last_modified_on
      type: object
    ErrorModel:
      additionalProperties: false
      properties:
        $schema:
          description: A URL to the JSON Schema for this object.
          examples:
            - https://example.com/schemas/ErrorModel.json
          format: uri
          readOnly: true
          type: string
        detail:
          description: >-
            A human-readable explanation specific to this occurrence of the
            problem.
          examples:
            - Property foo is required but is missing.
          type: string
        errors:
          description: Optional list of individual error details
          items:
            $ref: '#/components/schemas/ErrorDetail'
          type:
            - array
            - 'null'
        instance:
          description: >-
            A URI reference that identifies the specific occurrence of the
            problem.
          examples:
            - https://example.com/error-log/abc123
          format: uri
          type: string
        status:
          description: HTTP status code
          examples:
            - 400
          format: int64
          type: integer
        title:
          description: >-
            A short, human-readable summary of the problem type. This value
            should not change between occurrences of the error.
          examples:
            - Bad Request
          type: string
        type:
          default: about:blank
          description: A URI reference to human-readable documentation for the error.
          examples:
            - https://example.com/errors/example
          format: uri
          type: string
      type: object
    Versioning:
      additionalProperties: false
      properties:
        release_cycle:
          default: none
          description: Release cycle the Project or Package uses.
          enum:
            - none
            - regular
            - adhoc
          examples:
            - regular
          type: string
        release_interval_days:
          description: >-
            When ReleaseCycle is 'regular', indicates the interval in days that
            the Project or Package or Project or Package <em>intends</em> to cut
            <em>new</em> releases.
          format: int64
          minimum: 0
          type: integer
        scheme:
          default: unknown
          description: Versioning scheme the Project or Package uses.
          enum:
            - semantic
            - year-with-number
            - calver
            - unknown
          examples:
            - semantic
          type: string
        support_model:
          default: none
          description: The support model the Project or Package follows regarding releases.
          enum:
            - rolling
            - none
          examples:
            - rolling
          type: string
      required:
        - scheme
        - release_cycle
        - support_model
      type: object
    ErrorDetail:
      additionalProperties: false
      properties:
        location:
          description: >-
            Where the error occurred, e.g. 'body.items[3].tags' or
            'path.thing-id'
          type: string
        message:
          description: Error message text
          type: string
        value:
          description: The value at the given location
      type: object

````